

#include <p18f4580.h>	// p18cxxx.h must have current processor
#include "CAN18XX8.h"	// Purpose of using AN738 Subroutine !!
#include "WAP_LCD.H"	
#include <stdlib.h>

	
void Delay_100(void) ;

char 	Temp_ASCII[10] ;
char	WaitOnBus ;

union
	{
		unsigned char	Bytes[2] ;
		unsigned int		Word ;	
	}     AD_ALL ;

	unsigned char 	Var1,Var2 ;

	unsigned long	TX_ID1 ;
	BYTE			TX_Data_Buf1[8] ;

	unsigned long	RX_ID1 ;
	BYTE			RX_Data_Buf1[8] ;
	BYTE			RX_Data_Len1	;
	enum 			CAN_RX_MSG_FLAGS	RX1_Message_Flag ; 	

	unsigned long	RX_ID2 ;
	BYTE			RX_Data_Buf2[8] ;
	BYTE			RX_Data_Len2	;
	enum 			CAN_RX_MSG_FLAGS	RX2_Message_Flag ; 			

#define 			OUTGOING_ID		0X210 
#define			INCOMING_ID 		0X200

#define			MESSAGE_ID1			0x100
#define			RX_Filter0			0x200
#define			RX_Filter1			0x00
#define			RX_Filter2			0x00
#define			RX_Filter3			0x00
#define			RX_Filter4			0x00
#define			RX_Filter5			0x00
#define			RXB0_MASK		0x7ff
#define			RXB1_MASK		0x7ff

void main( void )
{

	PORTD = 0x00 ;	
	TRISD =  0x00 ;
	TRISBbits.TRISB2 = 0 ;			// CANTX
	TRISBbits.TRISB3 = 1 ;			// CANRX
	
	CMCON = 0b00000111 ;			//  Disable Comparator Module 
	
	//	***************************************************************									
	//	AD Modul initialize for PIC18F458X
	//	***************************************************************
	ADCON1 = 	0b00001110 ;
	ADCON2 = 	0b10100010 ;			//  Right Justified !!
	ADCON0 = 	0b00000001 ;			//  Initial ADCON0 for A/D Module 

	
		OpenLCD( ) ;
	
		Delay_100( ) ;
		
		putrsLCD("FL=      IN=        ") ;
		LCD_Set_Cursor(0,1) ;
		putrsLCD("ID=      AD=      ") ;
		
		itoa ( MESSAGE_ID1 ,Temp_ASCII ) ;
		LCD_Set_Cursor(3,0) ;
		putsLCD(Temp_ASCII ) ;
		
		itoa (RX_Filter0,Temp_ASCII ) ;
		LCD_Set_Cursor(3,1) ;
		putsLCD(Temp_ASCII ) ;
	
	//
	// Initialize CAN Communication Module !!
	// The Sequence of Parameter is SJW,BRP,PHASEG1,PHASEG2,PROPSEG, Mode !!
	//
	
	CANInitialize(    2,8,3,3,1,		CAN_CONFIG_LINE_FILTER_OFF & 
									CAN_CONFIG_SAMPLE_ONCE & 
									CAN_CONFIG_ALL_MSG &
									CAN_CONFIG_PHSEG2_PRG_ON ) ;

	CANSetOperationMode(CAN_OP_MODE_CONFIG) ;

	CANSetMask(CAN_MASK_B1, RXB0_MASK, CAN_CONFIG_STD_MSG ) ;	// Set Mask For Standard Data Frame 
	CANSetMask(CAN_MASK_B2, RXB1_MASK, CAN_CONFIG_STD_MSG ) ;
	
	CANSetFilter(CAN_FILTER_B1_F1, RX_Filter0  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B1_F2, RX_Filter1  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F1, RX_Filter2 , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F2, RX_Filter3  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F3, RX_Filter4  , CAN_CONFIG_STD_MSG) ;
	CANSetFilter(CAN_FILTER_B2_F4, RX_Filter5  , CAN_CONFIG_STD_MSG) ;

	CANSetOperationMode(CAN_OP_MODE_LISTEN) ;
		
	//	W[ܼ : WaitOnBus   
	//	 Message ID = 0x88  , KN WaitOnBus Ms . 
	//	>> åBN Mask / Filter ˬd} 
	//	MASK C|Ȭ : CAN_CONFIG_VALID_STD_MSG   

		WaitOnBus = 1 ;
		while ( WaitOnBus )
		{
			if ( CANIsRxReady( ) )
				{

					Delay_100() ;
					CANSendMessage(	MESSAGE_ID1 ,TX_Data_Buf1,5,CAN_TX_PRIORITY_0 &
									CAN_TX_STD_FRAME &
									CAN_TX_NO_RTR_FRAME ) ;

					CANReceiveMessage(&RX_ID1,RX_Data_Buf1,&RX_Data_Len1,&RX1_Message_Flag ) ;
					if ( RX_ID1 == 0x88 )	WaitOnBus = 0 ;
				}
		}

	
		CANInitialize(    2,8,3,3,1,	CAN_CONFIG_LINE_FILTER_OFF & 
									CAN_CONFIG_SAMPLE_ONCE & 
									CAN_CONFIG_VALID_STD_MSG &
									CAN_CONFIG_PHSEG2_PRG_ON ) ;
	

	TX_Data_Buf1[0] = 0x01 ;
	TX_Data_Buf1[1] = 0x02 ;
	TX_Data_Buf1[2] = 0x03 ;
	TX_Data_Buf1[3] = 0x04 ;
	TX_Data_Buf1[4] = 0x05 ;

	while (1)
	{
		Delay_100() ;
		CANSendMessage(	MESSAGE_ID1 ,TX_Data_Buf1,5,CAN_TX_PRIORITY_0 &
							CAN_TX_STD_FRAME &
							CAN_TX_NO_RTR_FRAME ) ;
	
		ADCON0bits.GO = 1 ;
		
		while ( ADCON0bits.GO) ;
		
		TX_Data_Buf1[3]  = ADRESH ;
		TX_Data_Buf1[4]  =  ADRESL ;
		
		LCD_Set_Cursor(12,1) ;
		putrsLCD("    ") ;
		LCD_Set_Cursor(12,1) ;
		
		AD_ALL.Bytes[0] = ADRESL ;
		AD_ALL.Bytes[1] = ADRESH ;
			
		itoa ( AD_ALL.Word , Temp_ASCII ) ;
		
		putsLCD( Temp_ASCII ) ;

		if ( CANIsRxReady( ) )

		{
			CANReceiveMessage(&RX_ID1,RX_Data_Buf1,&RX_Data_Len1,&RX1_Message_Flag ) ;

				AD_ALL.Bytes[1] = RX_Data_Buf1[3] ;		// ADRESH
				AD_ALL.Bytes[0] = RX_Data_Buf1[4] ;		// ADRESL
				
						LCD_Set_Cursor(12,0) ;
						puthexLCD(RX_Data_Buf1[3]) ;	
						puthexLCD(RX_Data_Buf1[4]) ;
		}
		
	}
	
}


void Delay_100(void)
{
	int  X1 ;

	for (X1 = 0 ; X1 < 10000 ; X1 ++ ) ;

}


//************************************************
//*       #pragma Interrupt Declarations         *
//************************************************
#pragma interrupt isr_high 		//	save = PRODL,PRODH,FSR0L,FSR0H
#pragma interruptlow isr_low 		//	save = WREG,STATUS,BSR,PRODL,PRODH,FSR0L,FSR0H

//************************************************
//* Function: isr_high_direct                    *
//*   - Direct execution to the actual           *
//*     high-priority interrupt code.            *
//************************************************
#pragma code isrhighcode = 0x0000008

void isr_high_direct(void)	
{  
   //***EXERCISE 2 CODE HERE***
                         										
     _asm 		//begin in-line assembly
     goto isr_high	//go to isr_high function
     _endasm 		//end in-line assembly
}

#pragma code


//************************************************
//* Function: isr_low_direct                     *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.             *
//************************************************
#pragma code isrlowcode = 0x0000018

void isr_low_direct(void)
{  
   //***EXERCISE 2 CODE HERE***
                        										
     _asm 		//begin in-line assembly
     goto isr_low	//go to isr_high function
     _endasm		//end in-line assembly
}
#pragma code


//************************************************
//* Function: isr_high(void)                     *     
//*   High priority interrupt will               *
//************************************************
void isr_high(void)
{
 
}									


//************************************************
//* Function: isr_low(void)                      *
//*   Low priority interrupt will                *
//*   - Check cause of interrupt and             *
//************************************************
void isr_low(void)
{
 
}				


